/*
** authored by rue
*/

/* Pre-Install Cleanup (for prior versions) */
{}

/* Main Install Routine */

// only load after the Pre-Install Cleanup completes
if (true) {
	// install constants
	const APP_DISPLAY_NAME = "Blank for CuteMenus";
	const APP_NAME = "Blank";
	const APP_PACKAGE = "/adblock.mozdev.org";
	const APP_VERSION = "";
	
	const APP_JAR_FILE = "Blank";
	const APP_CONTENT_FOLDER = "/";
	
	const INST_TO_PROFILE = "Install "+APP_DISPLAY_NAME+" in your profile?\n(..you wont have to reinstall when updating the browser).\n\nClick Cancel to install "+APP_DISPLAY_NAME+" in the browser root.";
	//const ROOT_FAILED___TRY_INST_TO_PROFILE = "You didn't have permission to install as root.\n Would you like to force profile-installation?";
	
	const profileChrome = getFolder("Profile", "chrome");

	const cuteJarInProfile = getFolder(profileChrome, "cutemenus.jar");
	const cuteJarInRoot = getFolder("chrome", "cutemenus.jar");
	const cuteJar = File.exists(cuteJarInProfile) ? 
			cuteJarInProfile
			: 
			(File.exists(cuteJarInRoot) ?
					cuteJarInRoot
					:
					null);

	const ThemeDirInProfile = getFolder(profileChrome, "CuteMenus Themes");
	const ThemeDirInRoot = getFolder("chrome", "CuteMenus Themes");
	const ThemeDir = (File.exists(ThemeDirInProfile) || File.exists(cuteJarInProfile)) ? 
			ThemeDirInProfile
			: 
			( (File.exists(ThemeDirInRoot) || File.exists(cuteJarInRoot)) ?
					ThemeDirInRoot
					:
					null);
	
	const previousJarInProfile = getFolder(ThemeDirInProfile, APP_JAR_FILE);
	const previousJarInRoot = getFolder(ThemeDirInRoot, APP_JAR_FILE);
	const hasPreviousJar = File.exists(previousJarInProfile) || File.exists(previousJarInRoot);
}

// initialize our install
initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);


// check for previous install
if (hasPreviousJar) {
	var installedTwice = (File.exists(previousJarInProfile) && File.exists(previousJarInRoot));
	var installedHere = (File.exists(previousJarInProfile)?"profile ":"")
	+ (installedTwice?"*and* ":"")
	+ (File.exists(previousJarInRoot)?"root ":"")
	+ (installedTwice?"directories":"directory");

	alert("Sorry:  "+APP_DISPLAY_NAME+" is already installed in your " + installedHere + ". "
		+ "\n\nPlease remove the file"
		+ (installedTwice?"s":"")
		+ " and try again.");
	cancelInstall(-23); // we can't overwrite, so don't install further
	
}
else {
	var errJar;

	// If cutemenus is installed twice (root + profile), ask user what to do..
	if (File.exists(cuteJarInProfile) && File.exists(cuteJarInRoot)) {
		var instToProfile = false;
		instToProfile = confirm(INST_TO_PROFILE);
		var themeDir = instToProfile ? ThemeDirInProfile : ThemeDirInRoot; }
	else themeDir = ThemeDir;
	
	// If CuteMenus is installed..
	if (themeDir) {
		// create Theme-Dir, if it doesn't exist
		if (!File.exists(themeDir)) dirCreate(themeDir);
	
		// install jar-file
		//errJar = addFile(APP_PACKAGE, APP_VERSION, APP_JAR_FILE, themeDir, null);
		
		// install theme-folder
		var jarFolder = getFolder(themeDir, APP_JAR_FILE); // step-1, create folder..
		errJar = addDirectory(APP_PACKAGE, APP_VERSION, APP_JAR_FILE, jarFolder, null); // ..and step-2, copy contents
		if (errJar == -214) errJar = dirCreate(jarFolder); // gracefully handle empty theme-folders
	}
	else errJar = "CUTEMENUS_NOT_INSTALLED";
	
	
	// if we've successfully installed the files, inform the user
	if (errJar == SUCCESS) {
		var err = performInstall();
		if (err == SUCCESS || err == 999) {
			alert(APP_DISPLAY_NAME + " " + APP_VERSION + " is now installed.\n"
				+"Just configure to activate."); } 
		else {
			alert("Install failed. Error code:" + err);
			cancelInstall(err); }
	} 
	else if (errJar == "CUTEMENUS_NOT_INSTALLED") {
		alert(APP_DISPLAY_NAME + " was not installed, because you don't have CuteMenus. \n"
		+"Grab the latest version from here:\n\n"
		+"adblock.mozdev.org/cutemenus/cutemenus-03-dev.xpi");
		cancelInstall(-24);
	}
	else {
		alert("Failed to create " +APP_JAR_FILE +"\n"
			+"You probably don't have appropriate permissions \n"
			+"(write access to your profile or chrome directory). \n"
			+"_____________________________\nError code:" + errJar);
		cancelInstall(errJar);
	}
	
}